testdir = "tests"

import glob, os, sys
sys.path.insert(0, testdir)

def runtest(testfile):
	testroot = os.path.splitext(testfile)[0]
	testname = os.path.basename(testroot)
	outname = "%s_out.txt" % testroot
	expected = "%s_expected.txt" % testroot
	outfile = open(outname, "w")
	sys.stdout = outfile
	try:
		__import__(testname)
	finally:
		sys.stdout = sys.__stdout__
	outfile.close()
	if not os.path.exists(expected):
		print "%s: No expected output" % testfile
		return False
	if open(outname).read() == open(expected).read():
		print "%s: Passed" % testfile
		return True
	else:
		print "%s: Failed" % testfile
		return False

def runtests(tests):
	ok = True
	for test in tests:
		ok = runtest(test) and ok
	if ok:
		print "All tests passed"
	else:
		print "Some tests failed"

def findtests():
	tests = []
	testpat = os.path.join(testdir, "*test.py")
	for filename in glob.glob(testpat):
		tests.append(filename)
	return tests

runtests(findtests())
